%define desktop_file 0
%if %{desktop_file}
%define desktop_file_utils_version 0.2.93
%endif
# Set this to 0 if you don't want to build gvim:
%define withgui 1

Summary: The VIM editor.
Name: vim
%define	baseversion 6.4
Version: %{baseversion}.006
%define vimversion vim64
Release: 1
License: Freeware
Group: Applications/Editors
Source0: ftp://ftp.vim.org/pub/vim/unix/vim-%{baseversion}.tar.bz2
Source1: ftp://ftp.vim.org/pub/vim/extra/vim-%{baseversion}-lang.tar.bz2
Source2: gvim.desktop
Source3: vimrc
Source4: ftp://ftp.vim.org/pub/vim/patches/README.patches
Source5: ftp://ftp.vim.org/pub/vim/extra/vim-%{baseversion}-extra.tar.bz2
Source6: ftp://ftp.vim.org/pub/vim/patches/MD5.patches
Patch0: vim-4.2-speed_t.patch
Patch1: vim-5.1-vimnotvi.patch
Patch2: vim-5.6a-paths.patch
Patch3: vim-6.0-fixkeys.patch
Patch4: vim-6.2-specsyntax.patch
Patch5: vim-6.0r-crv.patch
Patch10: xxd-locale.patch
Patch11: vim-6.0-gcc31.patch
# Patches 1000 and up are patches from the base maintainer.
# If you're as lazy as me, generate the list using
# (for i in `seq 1 21`; do echo "Patch`expr 1000 + $i`: ftp://ftp.vim.org/pub/vim/patches/6.2.`expr 1000 + $i | sed -e 's,^.,,'`"; done) >vimpatches
Patch1001: ftp://ftp.vim.org/pub/vim/patches/6.4.001
Patch1002: ftp://ftp.vim.org/pub/vim/patches/6.4.002
Patch1003: ftp://ftp.vim.org/pub/vim/patches/6.4.003
Patch1004: ftp://ftp.vim.org/pub/vim/patches/6.4.004
Patch1005: ftp://ftp.vim.org/pub/vim/patches/6.4.005
Patch1006: ftp://ftp.vim.org/pub/vim/patches/6.4.006

Patch3001: vim-6.1-syntax.patch
Patch3002: vim-6.1-rh1.patch
Patch3003: vim-6.1-rh2.patch
Patch3004: vim-6.1-rh3.patch
Buildroot: %{_tmppath}/%{name}-%{version}-root
Buildrequires: python-devel perl
%if %{desktop_file}
Requires: /usr/bin/desktop-file-install
BuildPrereq: desktop-file-utils >= %{desktop_file_utils_version}
%endif
Epoch: 1

%description
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and more.

%package common
Summary: The common files needed by any version of the VIM editor.
Group: Applications/Editors

%description common
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and more.  The
vim-common package contains files which every VIM binary will need in
order to run.

If you are installing any version of the VIM editor, you'll also need
to the vim-common package installed.

%package minimal
Summary: A minimal version of the VIM editor.
Group: Applications/Editors
Requires: vim-common
Obsoletes:  vim

%description minimal
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and more. The
vim-minimal package includes a minimal version of VIM, which is
installed into /bin/vi for use when only the root partition is
present.

%package enhanced
Summary: A version of the VIM editor which includes recent enhancements.
Group: Applications/Editors
Requires: vim-common
Obsoletes: vim-color

%description enhanced
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and more.  The
vim-enhanced package contains a version of VIM with extra, recently
introduced features like Python and Perl interpreters.

Install the vim-enhanced package if you'd like to use a version of the
VIM editor which includes recently added enhancements like
interpreters for the Python and Perl scripting languages.  You'll also
need to install the vim-common package.

%if "%{withgui}" == "1"
%package X11
Summary: The VIM version of the vi editor for the X Window System.
Group: Applications/Editors
Requires: vim-common
BuildRequires: gtk+-devel

%description X11
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and
more. VIM-X11 is a version of the VIM editor which will run within the
X Window System.  If you install this package, you can run VIM as an X
application with a full GUI interface and mouse support.

Install the vim-X11 package if you'd like to try out a version of vi
with graphics and mouse capabilities.  You'll also need to install the
vim-common package.
%endif

%prep
%setup -q -b 1 -b 5 -n %{vimversion}
%patch0 -p1 -b .4.2
%patch1 -p1 -b .vim
# fix rogue dependencies from sample code
chmod -x runtime/tools/mve.awk
%patch2 -p1 -b .paths
find . -name \*.paths | xargs rm -f
%patch3 -p1 -b .fixkeys
%patch4 -p1 -b .highlite
%patch5 -p1 -b .crv
%patch10 -p1 -b .xxdloc
#patch11 -p1 -b .gcc31
perl -pi -e "s,bin/nawk,bin/awk,g" runtime/tools/mve.awk

# Base patches...
# for i in `seq 1 21`; do echo "%patch`expr 1000 + $i` -p0 -b .vim`expr 1000 + $i | sed -e 's,^.,,'`"; done
%patch1001 -p0 -b .vim001
%patch1002 -p0 -b .vim002
%patch1003 -p0 -b .vim003
%patch1004 -p0 -b .vim004
%patch1005 -p0 -b .vim005
%patch1006 -p0 -b .vim006

%patch3001 -p1 -b .syntx
%patch3002 -p1 -b .rh1
%patch3003 -p1 -b .rh2
%patch3004 -p1 -b .rh3

%build
cd src
perl -pi -e "s,\\\$VIMRUNTIME,/usr/share/vim/%{vimversion},g" os_unix.h
perl -pi -e "s,\\\$VIM,/usr/share/vim/%{vimversion}/macros,g" os_unix.h

export CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64"
export CXXFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64"

%if %{withgui}
%configure --with-features=huge --enable-pythoninterp --enable-perlinterp \
 --disable-tclinterp --with-x=yes --enable-gui=auto --exec-prefix=/usr/X11R6 \
 --enable-xim --enable-multibyte --enable-fontset
perl -pi -e "s,-I/usr/local/include,,g" auto/config.mk # FIXME: remove once perl is fixed
%__make
cp vim gvim
%__make clean
%endif

%configure --prefix=/usr --with-features=huge --enable-pythoninterp \
 --enable-perlinterp --disable-tclinterp --with-x=no --enable-gui=no \
 --exec-prefix=/usr --enable-multibyte --enable-fontset
perl -pi -e "s,-I/usr/local/include,,g" auto/config.mk # FIXME: remove once perl is fixed
%__make
cp vim enhanced-vim
%__make clean

%configure --prefix='${DEST}'/usr --with-features=tiny --with-x=no \
  --enable-multibyte \
  --disable-pythoninterp --disable-perlinterp --disable-tclinterp \
  --with-tlib=termcap --enable-gui=no --disable-gpm --exec-prefix=/
perl -pi -e "s,-I/usr/local/include,,g" auto/config.mk # FIXME: remove once perl is fixed
%__make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p $RPM_BUILD_ROOT/usr/{bin,share/vim,X11R6/bin}

cd src
%makeinstall BINDIR=/bin DESTDIR=$RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT/bin/xxd $RPM_BUILD_ROOT/usr/bin
%__make installmacros DESTDIR=$RPM_BUILD_ROOT
%if "%{withgui}" == "1"
install -s -m755 gvim $RPM_BUILD_ROOT/usr/X11R6/bin
%endif
install -s -m755 enhanced-vim $RPM_BUILD_ROOT/usr/bin/vim

( cd $RPM_BUILD_ROOT
  mv ./bin/vimtutor ./usr/bin
  mv ./bin/vim ./bin/vi
  rm -f ./bin/rvim
  ln -sf vi ./bin/view
  ln -sf vi ./bin/ex
  ln -sf vi ./bin/rvi
  ln -sf vi ./bin/rview
  ln -sf vim ./usr/bin/ex
  ln -sf vim ./usr/bin/rvim
  ln -sf vim ./usr/bin/vimdiff
%if "%{withgui}" == "1"
  ln -sf gvim ./usr/X11R6/bin/gview
  ln -sf gvim ./usr/X11R6/bin/gex
%endif
  ln -sf gvim ./usr/X11R6/bin/evim
  perl -pi -e "s,$RPM_BUILD_ROOT,," .%{_mandir}/man1/vim.1 .%{_mandir}/man1/vimtutor.1
  rm -f .%{_mandir}/man1/rvim.1
  ln -sf vim.1.gz .%{_mandir}/man1/vi.1.gz
  ln -sf vim.1.gz .%{_mandir}/man1/rvi.1.gz
  ln -sf vim.1.gz .%{_mandir}/man1/gvim.1.gz
  ln -sf vim.1.gz .%{_mandir}/man1/evim.1.gz
  ln -sf vim.1.gz .%{_mandir}/man1/rvim.1.gz
  ln -sf vim.1.gz .%{_mandir}/man1/vimdiff.1.gz
%if "%{withgui}" == "1"
  ln -sf gvim ./usr/X11R6/bin/vimx
  %if %{desktop_file}
    mkdir -p $RPM_BUILD_ROOT/usr/share/applications
    desktop-file-install --vendor net \
        --dir $RPM_BUILD_ROOT/usr/share/applications \
        --add-category "Application;Development;X-Red-Hat-Base" \
        %{SOURCE2}
  %else
    mkdir -p ./etc/X11/applnk/Applications
    cp %{SOURCE2} ./etc/X11/applnk/Applications/gvim.desktop
  %endif
%endif
  install -s -m644 %{SOURCE3} ./usr/share/vim/%{vimversion}/macros/
  # ja_JP.ujis is obsolete, ja_JP.eucJP is recommended.
  ( cd ./usr/share/vim/%{vimversion}/lang; \
    ln -sf menu_ja_jp.ujis.vim menu_ja_jp.eucjp.vim )
)

# Dependency cleanups
chmod 644 $RPM_BUILD_ROOT/usr/share/vim/%{vimversion}/doc/vim2html.pl \
 $RPM_BUILD_ROOT/usr/share/vim/%{vimversion}/tools/*.pl \
 $RPM_BUILD_ROOT/usr/share/vim/%{vimversion}/tools/vim132
chmod 644 ../runtime/doc/vim2html.pl

mkdir -p $RPM_BUILD_ROOT/etc/profile.d
cat >$RPM_BUILD_ROOT/etc/profile.d/vim.sh <<EOF
if [ -n "\$BASH_VERSION" -o -n "\$KSH_VERSION" -o -n "\$ZSH_VERSION" ]; then
  # for bash, pdksh and zsh, only if no alias is already set
  alias vi >/dev/null 2>&1 || alias vi=vim
fi
EOF
cat >$RPM_BUILD_ROOT/etc/profile.d/vim.csh <<EOF
alias vi vim
EOF
chmod 0755 $RPM_BUILD_ROOT/etc/profile.d/*
(cd ../runtime; rm -rf doc; ln -svf ../../vim/%{vimversion}/doc docs;)

%clean
rm -rf $RPM_BUILD_ROOT

%files common
%defattr(-,root,root)
%doc README*.txt runtime/macros/README.txt runtime/tools/README.txt
%doc runtime/docs
/usr/share/vim
%config(noreplace) /usr/share/vim/%{vimversion}/macros/vimrc
%lang(af) /usr/share/vim/%{vimversion}/lang/af/*
%lang(cs) /usr/share/vim/%{vimversion}/lang/cs/*
%lang(de) /usr/share/vim/%{vimversion}/lang/de/*
%lang(es) /usr/share/vim/%{vimversion}/lang/es/*
%lang(fr) /usr/share/vim/%{vimversion}/lang/fr/*
%lang(it) /usr/share/vim/%{vimversion}/lang/it/*
%lang(ja) /usr/share/vim/%{vimversion}/lang/ja/*
%lang(ko) /usr/share/vim/%{vimversion}/lang/ko/*
%lang(pl) /usr/share/vim/%{vimversion}/lang/pl/*
%lang(sk) /usr/share/vim/%{vimversion}/lang/sk/*
%lang(uk) /usr/share/vim/%{vimversion}/lang/uk/*
%lang(zh_CN) /usr/share/vim/%{vimversion}/lang/zh_CN/*
%lang(zh_CN.UTF-8) /usr/share/vim/%{vimversion}/lang/zh_CN.UTF-8/*
%lang(zh_TW) /usr/share/vim/%{vimversion}/lang/zh_TW/*
/usr/bin/xxd
%{_mandir}/man1/vim.*
%{_mandir}/man1/ex.*
%{_mandir}/man1/vi.*
%{_mandir}/man1/view.*
%{_mandir}/man1/rvi.*
%{_mandir}/man1/rview.*
%{_mandir}/man1/xxd.*

%files minimal
%defattr(-,root,root)
/bin/ex
/bin/vi
/bin/view
/bin/rvi
/bin/rview

%files enhanced
%defattr(-,root,root)
/usr/bin/vim
/usr/bin/rvim
/usr/bin/vimdiff
/usr/bin/ex
/usr/bin/vimtutor
%config /etc/profile.d/vim.*
%{_mandir}/man1/rvim.*
%{_mandir}/man1/vimdiff.*
%{_mandir}/man1/vimtutor.*

%if "%{withgui}" == "1"
%files X11
%defattr(-,root,root)
%if %{desktop_file}
/usr/share/applications/*
%else
/etc/X11/applnk/*/gvim.desktop
%endif
/usr/X11R6/bin/gvim
/usr/X11R6/bin/evim
/usr/X11R6/bin/gview
/usr/X11R6/bin/gex
/usr/X11R6/bin/vimx
%{_mandir}/man1/gvim.*
%{_mandir}/man1/evim.*
%endif

%changelog
* Mon Dec 27 2005 Ryan Weaver <ryanw@falsehope.com> 6.4.006-1
- Updated to patch level 6.4.006
- 6.4.002  Unix: may change owner of wrong file in rare cases
- 6.4.003  (after 6.4.002) build problem on non-Unix system
- 6.4.004  "go" doesn't work correctly when 'virtualedit' is set
- 6.4.005  truncating message may write before buffer
- 6.4.006  ":argedit", "argdel" and ":argadd" used count argument

* Mon Oct 17 2005 Ryan Weaver <ryanw@falsehope.com> 6.4.001-1
- Updated to version 6.4
- Updated to patch level 6.4.001
- 6.4.001  (extra) Win32: can't compile the global IME code
